#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

/* --- vO̐ --- */
char *filen = "P4-3mkmtf.c";
char *title = "MTF߂vO";
/*
  GbW摜MTF쐬D
  ESFLSFZoMTFf[^ZoCo͂D
*/

/*  */
char *menu[] = { // ͂̍ۂ̃Rgi͕ϐƃNj
	" 1. GbW摜̃t@C   ",
	" 2. MTFf[^̃t@C    ",
	" 3. 摜̕                 ",
	" 4. 摜̍               ",
	" 5. o̓f[^             ",
	" 6. o̓f[^̃sNZ   ",
};

/* o */
/*
  MTFf[^̃t@Citext^j
*/

#define  PI  3.14159265358979  // ~

// vg^Cv錾
void init(double *img, int size, double val);
void read_data(char *fi, double *img, int size);
void write_data_txt(char *fi, double *img, int size);
void mklsf(double *lsf, int mx, double pl, double *img, int nx, int ny);
void mkmtf(double *mtf, double *lsf, int mx);
void fft1d(int ir, double *fr, double *fi, int nx);

// O[oϐ̐錾Ə
//char    g_f1[256] = "n4-1.img";  // 摜f[^̃t@C
//char    g_f2[256] = "n4-3.txt";  // MTFf[^̃t@C

char    g_f1[256] = "edge_a2_th3.0.img";  // 摜f[^̃t@C
char    g_f2[256] = "n4-3.txt";  // MTFf[^̃t@C

int     g_nx = 256;   // 摜̕
int     g_ny = 256;   // 摜̍
int     g_mx = 256;   // o̓f[^
double  g_pl = 0.1;   // o̓f[^̃sNZiTusNZlj
double *g_img;        // 摜f[^̈
double *g_lsf;        // LSFf[^̈
double *g_mtf;        // MTFf[^̈

// *** vOŎgpvO[oϐ̊mFE ***
void getparameter()
{
	int   i = 0;
	char  dat[256];

	// ϐւ̒l̓
	fprintf(stdout, "\n%s\n\n", title);

	fprintf(stdout, " %s [%s] :", menu[i++], g_f1);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = '\0'; strcpy(g_f1, dat); }
	fprintf(stdout, " %s [%s] :", menu[i++], g_f2);
	if (*fgets(dat, 256, stdin) != '\n') { dat[strlen(dat) - 1] = '\0'; strcpy(g_f2, dat); }
	fprintf(stdout, " %s [%d] :", menu[i++], g_nx);
	if (*fgets(dat, 256, stdin) != '\n')  g_nx = atoi(dat);
	fprintf(stdout, " %s [%d] :", menu[i++], g_ny);
	if (*fgets(dat, 256, stdin) != '\n')  g_ny = atoi(dat);
	fprintf(stdout, " %s [%d] :", menu[i++], g_mx);
	if (*fgets(dat, 256, stdin) != '\n')  g_mx = atoi(dat);
	fprintf(stdout, " %s [%f] :", menu[i++], g_pl);
	if (*fgets(dat, 256, stdin) != '\n')  g_pl = atof(dat);
}

// *** C֐ ***
int main(void)
{
	// vOŎgpϐ̓
	getparameter();

	// 摜̈̃𓮓IɊm
	g_img = (double *)malloc((size_t)g_nx*g_ny * sizeof(double));
	g_lsf = (double *)malloc((size_t)g_mx * 2 * sizeof(double));
	g_mtf = (double *)malloc((size_t)g_mx * sizeof(double));

	// LSFMTFf[^̈̏
	init(g_lsf, g_mx * 2, 0.0);
	init(g_mtf, g_mx, 0.0);

	// GbW摜̓
	read_data(g_f1, g_img, g_nx*g_ny);

	// LSF̍쐬
	mklsf(g_lsf, g_mx*2, g_pl, g_img, g_nx, g_ny);

	// MTF̍쐬
	mkmtf(g_mtf, g_lsf, g_mx * 2);

	// LSFf[^̏o
	write_data_txt(g_f2, g_mtf, g_mx);

	free(g_img);
	free(g_lsf);
	free(g_mtf);
	return 0;
}

// *** LSF摜쐬 ***
// double  *mtf; // MTFf[^̈
// double  *lsf; // LSFf[^̈
// int     mx;   // LSF̃f[^
void mkmtf(double *mtf, double *lsf, int mx)
{
	int     i;
	double  *lsi;  // LSFf[^̋
	
	// 摜̈̃𓮓IɊm
	lsi = (double *)malloc((size_t)mx * sizeof(double));

	// lsȉ
	init(lsi, mx, 0.0);

	// lsft[GϊiFFTj
	fft1d(1, lsf, lsi, mx);

	// ̔MTFƂ
	// _̒lŋKiiől1ɂj
	for (i = 0; i < mx / 2; i++)
	{
		mtf[i] = lsf[i + mx / 2] / lsf[mx / 2];
	}

	free(lsi);
}

// *** GbWʒl̎Zo ***
// double *img; // GbW摜f[^
// int     nx;   // 摜̕
// int     ny;   // 摜̍
// int     ln;   // GbWʒlZo郉Cԍicj
double edgepoint(double *img, int nx, int ny, int ln)
{
	int     i, a = 1, b = 0;
	double  max;
	double  da, db, dc;

	// y ln Cڂ̃GbWʒlZo
	//iől1/2ȏɂȂOォ`Ԃŋ߂j
	max = img[ln*nx];
	for (i = 1; i < nx; i++)
	{
		if (max < img[ln*nx+i]) max = img[ln*nx + i];
	}
	for (i = 0; i < nx; i++)
	{
		if (img[ln*nx + i] > max / 2)
		{
			a = i;
			break;
		}
	}
	b = a - 1;

	// `ԂW߂
	dc = img[ln*nx + a] - img[ln*nx + b];
	da = (img[ln*nx + a] - max/2) / dc;
	db = 1 - da;

	return a*db + b*da;
}

// *** f[^̌iSwapj***
// double *dat   // f[^
// int    i;     // iԖ
// int    j;     // jԖ
void swap(double *dat, int i, int j)
{
	double buff;
	
	buff = dat[i];
	dat[i] = dat[j];
	dat[j] = buff;
}

// *** LSF摜쐬 ***
// double  *lsf; // LSFf[^̈
// int     mx;   // LSF̃f[^
// double  pl;   // LSF̃sNZiTusNZj
// double  *img; // 摜f[^̈
// int     nx;   // 摜̕
// int     ny;   // 摜̍
void mklsf(double *lsf, int mx, double pl, double *img, int nx, int ny)
{
	int     i, j;
	double  a, b, th, si, co, x0;
	double  *pox;        // X΂߂xW
	double  *esf;        // ESF̃f[^

	pox = (double *)malloc((size_t)nx*ny * sizeof(double));
	esf = (double *)malloc((size_t)mx * sizeof(double));

	// 0 Cڂ̃GbWʒl
	a = edgepoint(img, nx, ny, 0);

	// (ny-1) Cڂ̃GbWʒl
	b = edgepoint(img, nx, ny, ny - 1);

	// XΊpx̌vZ
	th = atan2(b - a, (double)ny);
	printf("XΊpxF%f x\n", th * 180 / PI);
	
	// XΊpx߂xW̎Zo
	si = sin(th);
	co = cos(th);
	for (i = 0; i < ny; i++)
	{
		double y = ny / 2 - i; // yW
		for (j = 0; j < nx; j++)
		{
			double x = j - nx / 2; // SGbWʒlɍ킹xW
			pox[i*nx + j] = x*co + y*si; // X΂߂xW
		}
	}

	// xWɑ΂ĉflɕבւiI\[gj
	for (i = 0; i < nx*ny - 1; i++)
	{
		double min = pox[i];
		int    im = i;
		for (j = i + 1; j < nx*ny; j++)
		{
			if (min > pox[j])
			{
				min = pox[j];
				im = j;
			}
		}
		swap(pox, i, im);
		swap(img, i, im);
	}

	// lɂȂʒl̓
	a = edgepoint(img, nx*ny, 1, 0);
	x0 = pox[(int)(a + 0.5)];

	// x0𒆐SplԊu𕽋ω
	for (i = 0; i < mx; i++)
	{
		double x = (i - mx / 2)*pl + x0;
		double ave = 0;
		int    count = 0;
		for (j = 0; j < nx*ny; j++)
		{
			if (pox[j] >= x - pl/2 && pox[j] < x + pl/2)
			{
				ave += img[j];
				count++;
			}
		}
		esf[i] = ave / count;
	}

	// ׂ̉flƂ̍LSFZo
	for (i = 0; i < mx-1; i++)
	{
		lsf[i] = (esf[i + 1] - esf[i]) / pl;
	}
	lsf[i] = 0; // Ō̉fl0ɂ

	free(pox);
	free(esf);
}

// *** 摜̈̏ ***
// double *img;  // 摜̈
// int    size;  // 摜̈̃f[^ifj
// double  val;  // l
void init(double *img, int size, double val)
{
	int  i;
	for (i = 0; i < size; i++)
		img[i] = val;
}

// *** 2摜f[^̓́ifloat^t@CdoubleƂḗj***
// char *fi;    // ͉摜̃t@C
// double *img; // ͉摜f[^
// int  size;   // ͉摜̃TCYi~ pixelj
void read_data(char *fi, double *img, int size)
{
	int i;
	float buff;
	FILE   *fp;

	if ((fp = fopen(fi, "rb")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	for (i = 0; i < size; i++)
	{
		fread(&buff, sizeof(float), 1, fp);
		img[i] = buff;
	}
	fclose(fp);
}

// *** 2摜f[^̏óidoublef[^text^Ƃďój***
// char *fi;    // o͉摜̃t@C
// double *img; // o͉摜f[^
// int  size;   // o͉摜̃TCYi~ pixelj
void write_data_txt(char *fi, double *img, int size)
{
	int i;
	FILE   *fp;

	if ((fp = fopen(fi, "w")) == NULL) {
		fprintf(stderr, " G[Ft@CJ܂[%s].\n", fi);
		exit(1);
	}
	for (i = 0; i < size; i++)
	{
		fprintf(fp, "%f\n", img[i]);
	}
	fclose(fp);
}

/* --- vO̐ ---
@t[GϊiFFTjp̊֐

 FFTvOgƂ5̔zpӂĂ
 double  xr[nx]    : FFTp̎f[^
 double  xi[nx]    : FFTp̋f[^
 double  si[nx/2]  : FFTŎgTCf[^
 double  co[nx/2]  : FFTŎgRTCf[^
 int     brv[nx]   : FFTŎgo^tCZf[^

 nx        : 1FFT̃f[^i2̃xLj

 FFT֐ɕKvȃTCƃRTCƃo^tCZf[^쐬֐
 void FFTInit(int nx, double *si, double *co, int *brv);

 1FFTs֐iFFTASYj
 void FFT(int ir, int nx, double *xr, double *xi, double *si, double *co, int *brv);

 1FFTs֐is܂Łj
 void fft1d(int ir, double *fr, double *fi, int nx);

*/

// o^tCZ̓ւ
// int     nx;    // f[^
// double  *xr;   // ̃f[^  xr[nx]
// double  *xi;   // ̃f[^  xi[nx]
// int     *brv;  // p̃f[^  brv[nx]
void bitrev(int nx, double *xr, double *xi, int *brv)
{
	int     i, j;
	double   a, b;
	for (i = 0; i < nx; i++) {
		j = brv[i];
		if (i < j) {
			a = xr[i];
			b = xi[i];
			xr[i] = xr[j];
			xi[i] = xi[j];
			xr[j] = a;
			xi[j] = b;
		}
	}
}

// 1FFTs֐iFFTASYj
// int     ir;    // ϊ(1)Ƌtϊ(-1)
// int     nx;    // 1FFT̃f[^
// double  *xr;   // ̃f[^          xr[nx]
// double  *xi;   // ̃f[^          xi[nx]
// double  *si;   // FFTp̃TCf[^   si[nx/2]
// double  *co;   // FFTp̃RTCf[^ co[nx/2]
// int     *brv;  // FFTp̓ւf[^ brv[nx]
void FFT(int ir, int nx, double *xr, double *xi, double *si, double *co, int *brv)
{
	int     i, j, n1, n2 = nx, j3, j4, k, l, ll, d = 1, g;
	double   a, b, c, s;

	for (l = 1; l <= nx / 2; l *= 2, d += d) {
		g = 0;
		ll = n2;
		n2 /= 2;
		for (k = 1; k <= n2; k++) {
			n1 = k - ll;
			c = co[g];
			s = ir*si[g];
			g += d;
			for (j = ll; j <= nx; j += ll) {
				j3 = j + n1 - 1;
				j4 = j3 + n2;
				a = xr[j3] - xr[j4];
				b = xi[j3] - xi[j4];
				xr[j3] += xr[j4];  xi[j3] += xi[j4];
				xr[j4] = c*a + s*b; xi[j4] = c*b - s*a;
			}
		}
	}

	bitrev(nx, xr, xi, brv);
	if (ir == -1)
		for (i = 0; i < nx; i++) {
			xr[i] /= nx;
			xi[i] /= nx;
		}
}

// f[^쐬p֐
// int  nx;  // f[^
// int  nn;  // Õf[^ԍ
int br(int nx, int nn)
{
	int  r, c;
	r = 0;
	for (c = 1; c <= nx / 2; c <<= 1) {
		r <<= 1;
		if ((nn&c) != 0)
			r++;
	}
	return(r);
}

// FFTp̃f[^쐬p̊֐
// FFT֐gO1xgpĕKvȃf[^쐬
// int      nx;   // FFT̃f[^
// double  *si;   // TCf[^pz   si[nx/2]
// double  *co;   // RTCf[^pz co[nx/2]
// int     *brv;  // f[^pz brv[nx]
void FFTInit(int nx, double *si, double *co, int *brv)
{
	double  d = 2.0*PI / nx;
	int     i;
	for (i = 0; i < nx / 4; i++) {
		si[i] = sin(d*i);
		co[i + nx / 4] = -si[i];
	}
	for (i = nx / 4; i < nx / 2; i++) {
		si[i] = sin(d*i);
		co[i - nx / 4] = si[i];
	}
	for (i = 0; i < nx; i++)
		brv[i] = br(nx, i);
}


// 1FFTs֐is܂Łj
// int     ir;   // ϊ(1)Ƌtϊ(-1)
// double  *fr;  // 1FFT̎̃f[^ fr[nx]
// double  *fi;  // 1FFT̋̃f[^ fi[nx]
// int     nx;   // 1FFT̃f[^
void fft1d(int ir, double *fr, double *fi, int nx)
{
	int      i;
	double  *xr, *xi, *si, *co;
	int *br;

	// FFT֐pf[^̈̃𓮓IɊm
	xr = (double *)malloc((size_t)nx * sizeof(double));
	xi = (double *)malloc((size_t)nx * sizeof(double));
	si = (double *)malloc((size_t)nx / 2 * sizeof(double));
	co = (double *)malloc((size_t)nx / 2 * sizeof(double));
	br = (int *)malloc((size_t)nx * sizeof(int));

	// FFT̏
	FFTInit(nx, si, co, br);

	// f[^̓ւi_炷j
	for (i = 0; i < nx / 2; i++)
	{
		xr[i] = fr[i + nx / 2];
		xr[i + nx / 2] = fr[i];
		xi[i] = fi[i + nx / 2];
		xi[i + nx / 2] = fi[i];
	}

	// FFT̎s
	FFT(ir, nx, xr, xi, si, co, br);

	// f[^̓ւi_߂j
	for (i = 0; i < nx / 2; i++)
	{
		fr[i + nx / 2] = xr[i];
		fr[i] = xr[i + nx / 2];
		fi[i + nx / 2] = xi[i];
		fi[i] = xi[i + nx / 2];
	}

	// f[^̈̃J
	free(xr);
	free(xi);
	free(si);
	free(co);
	free(br);
}
